import { Json } from 'redux-store-generator';
import { ConnectedStoreActions, RequestsActionBag, SagasActionBag, withNodeName } from '../types/types';
export declare const SIGNATURE_CONFIG: {
    '@@redux-connected/CONFIG_ACTION': boolean;
};
export declare const SIGNATURE_STATUS: {
    '@@redux-connected/STATUS_ACTION': boolean;
};
export declare const SIGNATURE_GLOBAL_STATS: {
    '@@redux-connected/GLOBAL_STATS_ACTION': boolean;
};
export declare const SIGNATURE_GLOBAL_SETTINGS: {
    '@@redux-connected/GLOBAL_SETTINGS_ACTION': boolean;
};
export declare const SIGNATURE_SAGA: {
    '@@redux-connected/SAGA_ACTION': boolean;
};
export declare const config_setAction: <T>(configName: string, extra?: Json | undefined) => (payload: Partial<T> & withNodeName) => {
    type: string;
    payload: {
        [x: string]: Partial<T> & withNodeName;
    };
};
export declare const config_patchAction: <T>(configName: string, extra?: Json | undefined) => (payload: Partial<T> & withNodeName) => {
    type: string;
    payload: {
        [x: string]: Partial<T> & withNodeName;
    };
};
export declare const config_all: <T>(configName: string, extra?: Json | undefined) => {
    set: (payload: Partial<T> & withNodeName) => {
        type: string;
        payload: {
            [x: string]: Partial<T> & withNodeName;
        };
    };
    patch: (payload: Partial<T> & withNodeName) => {
        type: string;
        payload: {
            [x: string]: Partial<T> & withNodeName;
        };
    };
};
export declare const requests: RequestsActionBag;
export declare const apiActions: ConnectedStoreActions;
export declare const sagaActions: SagasActionBag;
