"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sagaActions = exports.apiActions = exports.requests = exports.config_all = exports.config_patchAction = exports.config_setAction = exports.SIGNATURE_SAGA = exports.SIGNATURE_GLOBAL_SETTINGS = exports.SIGNATURE_GLOBAL_STATS = exports.SIGNATURE_STATUS = exports.SIGNATURE_CONFIG = void 0;
var actions_1 = require("redux-store-generator/lib/actions");
exports.SIGNATURE_CONFIG = { '@@redux-connected/CONFIG_ACTION': true }; // prettier-ignore
exports.SIGNATURE_STATUS = { '@@redux-connected/STATUS_ACTION': true }; // prettier-ignore
exports.SIGNATURE_GLOBAL_STATS = { '@@redux-connected/GLOBAL_STATS_ACTION': true }; // prettier-ignore
exports.SIGNATURE_GLOBAL_SETTINGS = { '@@redux-connected/GLOBAL_SETTINGS_ACTION': true }; // prettier-ignore
exports.SIGNATURE_SAGA = { '@@redux-connected/SAGA_ACTION': true }; // prettier-ignore
// ============== config ==============
var config_setAction = function (configName, extra) { return function (payload) {
    var _a;
    var nodeName = payload.nodeName;
    delete payload['nodeName'];
    return __assign({ type: "SET_" + configName.toUpperCase(), payload: (_a = {},
            _a[nodeName] = payload,
            _a) }, extra);
}; };
exports.config_setAction = config_setAction;
var config_patchAction = function (configName, extra) { return function (payload) {
    var _a;
    var nodeName = payload.nodeName;
    delete payload['nodeName'];
    return __assign({ type: "PATCH_" + configName.toUpperCase(), payload: (_a = {},
            _a[nodeName] = payload,
            _a) }, extra);
}; };
exports.config_patchAction = config_patchAction;
var config_all = function (configName, extra) {
    return {
        set: exports.config_setAction(configName, extra),
        patch: exports.config_patchAction(configName, extra),
    };
};
exports.config_all = config_all;
exports.requests = {
    push: function (request) { return ({ type: 'PUSH_REQUEST', payload: request }); },
    patch: function (id, request) { return ({ type: 'PATCH_REQUEST', payload: { id: id, request: request } }); },
    remove: function (id) { return ({ type: 'REMOVE_REQUEST', payload: { id: id } }); },
    purge: function () { return ({ type: 'PURGE_COMPLETED' }); },
};
// ============== from store structure ==============
exports.apiActions = {
    api: {
        global: {
            settings: actions_1.single_all('API_GLOBAL_SETTINGS', exports.SIGNATURE_GLOBAL_SETTINGS),
            stats: actions_1.single_all('API_GLOBAL_STATS', exports.SIGNATURE_GLOBAL_STATS),
        },
        config: exports.config_all('API_ENDPOINTS_CONFIG', exports.SIGNATURE_CONFIG),
        status: exports.config_all('API_STATUS', exports.SIGNATURE_STATUS),
        requests: exports.requests,
    },
};
exports.sagaActions = actions_1.collection_all('SAGA', exports.SIGNATURE_SAGA);
//# sourceMappingURL=actions.js.map