"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.state = void 0;
var redux_store_generator_1 = require("redux-store-generator");
var types_1 = require("../types/types");
exports.state = {
    apiGlobalSettings: {
        beat: 3000,
        maxConcurrentRequests: 30,
        retryStrategy: types_1.RetryStrategy.X3_TIMES,
        delayBetweenRetries: 3000,
        verifyInternetConnection: true,
        verifyAfterXMillisOfFailures: 10 * 1000,
    },
    apiGlobalStats: {
        lastSuccessfulRequestTS: 0,
    },
    sagas: {
        get: { isRunning: false },
        requests: { isRunning: false },
        save: { isRunning: false },
    },
    endpointsConfig: {
        appState: {
            connectionType: types_1.ConnectionType.NONE,
            retryStrategy: types_1.RetryStrategy.X3_TIMES,
            requestsPerMinute: 0,
            pagination: false,
            nodeType: redux_store_generator_1.NodeType.SINGLE_NODE,
        },
        products: {
            connectionType: types_1.ConnectionType.REST,
            retryStrategy: types_1.RetryStrategy.X3_TIMES,
            requestsPerMinute: 3,
            pagination: false,
            nodeType: redux_store_generator_1.NodeType.COLLECTION_NODE,
        },
        logs: {
            connectionType: types_1.ConnectionType.REST,
            retryStrategy: types_1.RetryStrategy.X3_TIMES,
            requestsPerMinute: 3,
            pagination: false,
            nodeType: redux_store_generator_1.NodeType.QUEUE_NODE,
        },
        chats: {
            connectionType: types_1.ConnectionType.REST,
            retryStrategy: types_1.RetryStrategy.X3_TIMES,
            requestsPerMinute: 3,
            pagination: false,
            nodeType: redux_store_generator_1.NodeType.QUEUE_NODE,
        },
    },
    status: {
        appState: {
            connectionStatus: types_1.ConnectionStatus.IDLE,
            lastRequest: {
                startTS: 0,
                responseTS: 0,
                completedTS: 0,
                responseSize: 0,
                duration: 0,
                result: types_1.RequestResult.NONE,
            },
        },
        products: {
            connectionStatus: types_1.ConnectionStatus.IDLE,
            lastRequest: {
                startTS: 0,
                responseTS: 0,
                completedTS: 0,
                responseSize: 0,
                duration: 0,
                result: types_1.RequestResult.NONE,
            },
        },
        logs: {
            connectionStatus: types_1.ConnectionStatus.IDLE,
            lastRequest: {
                startTS: 0,
                responseTS: 0,
                completedTS: 0,
                responseSize: 0,
                duration: 0,
                result: types_1.RequestResult.NONE,
            },
        },
        chats: {
            connectionStatus: types_1.ConnectionStatus.IDLE,
            lastRequest: {
                startTS: 0,
                responseTS: 0,
                completedTS: 0,
                responseSize: 0,
                duration: 0,
                result: types_1.RequestResult.NONE,
            },
        },
    },
};
//# sourceMappingURL=sample.structure.js.map