import { StoreNodeTypes, StoreStructure } from 'redux-store-generator';
import { StoreStructureApi } from '../types/types';
export declare const storeStructure: StoreNodeTypes;
export declare const state: StoreStructureApi;
export declare type AppState = {
    isLoading: boolean;
    email?: string;
};
export declare type User = {
    userName?: string;
    email?: string;
};
export declare type Product = {
    id: string;
    title: string;
    price: number;
    thumbnail: string;
    imageUrl: string;
    color: string;
    shippingDate: string;
};
export declare type Products = Record<string, Product>;
export declare type Log = {
    id: string;
};
export declare type Logs = Array<Log>;
export interface MyStore extends StoreStructure {
    appState: AppState;
    user: User;
    products: Products;
    logs: Logs;
}
export declare const myStoreState: MyStore;
export declare const partialStore: {
    _api: {
        actionTypes: {
            PATCH_APPSTATE: {
                verb: string;
                nodeName: string;
            };
            PATCH_PRODUCT: {
                verb: string;
                nodeName: string;
            };
            SET_LOG: {
                verb: string;
                nodeName: string;
                isLocal: boolean;
            };
        };
        endpointsConfig: {
            appState: {
                nodeType: string;
                connectionType: string;
            };
            products: {
                nodeType: string;
                connectionType: string;
            };
            logs: {
                nodeType: string;
                connectionType: string;
            };
            chats: {
                nodeType: string;
                connectionType: string;
            };
        };
    };
};
export default state;
