"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useMonitor = void 0;
var react_use_1 = require("react-use");
var useStore_1 = require("./useStore");
var meta_1 = require("../sagas/_utils/meta");
function useMonitor(options, predicate) {
    var _a = react_use_1.useCounter(1), sequence = _a[0], inc = _a[1].inc;
    var _b = react_use_1.useList([]), readings = _b[0], _c = _b[1], push = _c.push, clear = _c.clear;
    var onlyLast = (options || {}).onlyLast;
    useStore_1.useStore(function (_a) {
        var state = _a.state, action = _a.action;
        inc();
        var reading = {
            meta: meta_1.generateMeta(sequence),
            action: cleanAction(action),
        };
        if (options && options.monitorState) {
            reading.state = state;
        }
        if (onlyLast) {
            clear();
        }
        push(reading);
    }, predicate);
    return [readings, { clear: clear }];
}
exports.useMonitor = useMonitor;
function cleanAction(action) {
    var output = __assign({}, action);
    delete output['resolve'];
    delete output['reject'];
    return output;
}
//# sourceMappingURL=useMonitor.js.map