"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useStore = void 0;
var react_1 = require("react");
var globals_1 = require("../globals");
function useStore(callback, predicate) {
    var store = globals_1.default.connectedStore;
    react_1.useEffect(function () {
        var unsubscribe = store.subscribe(function () {
            var state = store.getState();
            var action = state._lastAction;
            if (!predicate || predicate(action)) {
                callback({
                    state: state,
                    action: action,
                });
            }
        });
        return function () { return unsubscribe(); };
    }, [callback, predicate]);
}
exports.useStore = useStore;
//# sourceMappingURL=useStore.js.map