import { StoreStructure } from 'redux-store-generator';
import { Sagas, EndpointsConfigOverrides, RetryStrategy } from './types/types';
export declare const generateInitialState: <T extends StoreStructure>(storeState: T, apiConfigOverrides?: EndpointsConfigOverrides | undefined) => {
    apiGlobalSettings: {
        beat: number;
        maxConcurrentRequests: number;
        retryStrategy: RetryStrategy;
        delayBetweenRetries: number;
        verifyInternetConnection: boolean;
        verifyAfterXMillisOfFailures: number;
    };
    apiGlobalStats: {
        internetConnectionAvailable?: boolean | undefined;
        lastSuccessfulRequestTS?: number | undefined;
    };
    endpointsConfig: any;
    status: any;
    actionTypes: any;
    nodeTypes: any;
    requests: never[];
};
export declare const generateSagasInitialState: (sagas: Sagas) => any;
