"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.filterMiddleware = void 0;
var selectors = require("../selectors/selectors");
var types_1 = require("../types/types");
var dispatchP_1 = require("../sagas/_utils/dispatchP");
var filterMiddleware = function (store) { return function (next) { return function (action) {
    var skip = false;
    var state = store.getState();
    var actionTypes = selectors.$actionTypes(state);
    var apiInfo = actionTypes[action.type];
    if (apiInfo) {
        var allConfigs = selectors.$config(state);
        var nodeName = apiInfo.nodeName, isLocal = apiInfo.isLocal;
        var config = allConfigs[nodeName];
        var connectionType = config.connectionType;
        // not REST
        if (connectionType !== types_1.ConnectionType.REST) {
            skip = true;
        }
        // local action
        if (isLocal) {
            skip = true;
        }
    }
    else {
        // action is foreign
        if (action['@@redux-connected/ACTION_ID']) {
            skip = true;
        }
    }
    if (skip) {
        var nextAction = dispatchP_1.clearActionP(action);
        action.resolve({ nextAction: nextAction });
        return;
    }
    return next(action);
}; }; };
exports.filterMiddleware = filterMiddleware;
//# sourceMappingURL=midFilter.js.map