"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResponseBuilder = void 0;
var meta_1 = require("./meta");
var sequence = 1;
var ResponseBuilder = /** @class */ (function () {
    function ResponseBuilder(request) {
        this.output = {};
        this.response = {};
        this.output.meta = meta_1.generateMeta(sequence++);
        this.output.request = request;
    }
    ResponseBuilder.prototype.withAxiosResponse = function (axiosResponse) {
        this.response = axiosResponse;
        return this;
    };
    ResponseBuilder.prototype.withIsSuccess = function (isSuccess) {
        this.output.isSuccess = isSuccess;
        return this;
    };
    ResponseBuilder.prototype.withIsError = function (isError) {
        this.output.isError = isError;
        return this;
    };
    ResponseBuilder.prototype.withErrorType = function (errorType) {
        this.output.errorType = errorType;
        return this;
    };
    ResponseBuilder.prototype.withErrorMessage = function (errorMessage) {
        this.output.errorMessage = errorMessage;
        return this;
    };
    ResponseBuilder.prototype.build = function () {
        this.output.status = this.response.status;
        this.output.statusText = this.response.statusText;
        this.output.data = this.response.data;
        this.output.headers = this.response.headers;
        return this.output;
    };
    return ResponseBuilder;
}());
exports.ResponseBuilder = ResponseBuilder;
//# sourceMappingURL=ResponseBuilder.js.map