import { Json } from 'redux-store-generator';
import { StoreOptions } from './../../types/types';
export declare const DEFAULT_STORE_OPTIONS: Partial<StoreOptions>;
export declare class StoreBuilder {
    private definition;
    private preMiddlewares;
    private postMiddlewares;
    private sagaMiddleware;
    constructor(name: string);
    withInitialState(initialState: Json): this;
    withReducers(reducers: any): this;
    withMiddlewares(...middlewares: any): this;
    withPreMiddlewares(...middlewares: any): this;
    withPostMiddlewares(...middlewares: any): this;
    withSagas(...sagas: any): this;
    withOptions(options: Partial<StoreOptions>): this;
    get options(): StoreOptions;
    fireSagas: (store: any) => void;
    build(): any;
}
