import { ApiRequest, ApiServerConfiguration } from './../../types/types';
import { AxiosInstance } from 'axios';
import { Json } from 'redux-store-generator';
export declare let instance: AxiosInstance;
export declare const DEFAULT_API_ENDPOINTS_CONFIGURATION: {
    internetConnectionCheckUrl: string;
};
export declare const configureAxiosInstance: (apiServerConfiguration: ApiServerConfiguration) => void;
export declare const api: {
    get: (path: string, params?: Json | undefined) => Promise<import("axios").AxiosResponse<any>>;
    post: (path: string, data?: Json | undefined) => Promise<import("axios").AxiosResponse<any>>;
    patch: (path: string, data?: Json | undefined) => Promise<import("axios").AxiosResponse<any>>;
    put: (path: string, data?: Json | undefined) => Promise<import("axios").AxiosResponse<any>>;
    delete: (path: string) => Promise<import("axios").AxiosResponse<any>>;
};
export declare const fireRequest: (request: ApiRequest) => Promise<unknown>;
export declare const checkConnection: (url: string) => Promise<boolean>;
