"use strict";
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.get = void 0;
var selectors = require("../../selectors/selectors");
var actions_1 = require("../../connected/actions");
var logger_1 = require("./../logger/logger");
var effects_1 = require("redux-saga/effects");
var RequestsBuilder_1 = require("../_utils/RequestsBuilder");
var types_1 = require("./../../types/types");
function get(apiInfo, action) {
    var configs, nodeName, verb, config, connectionType, nodeTypes, nodeType, request, nextAction;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, effects_1.select(selectors.$config)];
            case 1:
                configs = (_a.sent());
                nodeName = apiInfo.nodeName, verb = apiInfo.verb;
                config = configs[nodeName];
                connectionType = config.connectionType;
                return [4 /*yield*/, effects_1.select(selectors.$nodeTypes)];
            case 2:
                nodeTypes = (_a.sent());
                nodeType = nodeTypes[nodeName];
                if (!(connectionType !== types_1.ConnectionType.REST)) return [3 /*break*/, 4];
                return [4 /*yield*/, effects_1.put(logger_1.logm("connection type is " + connectionType + ". skipping"))];
            case 3:
                _a.sent();
                if (typeof action.resolve === 'function') {
                    action.resolve({ ignored: true });
                }
                return [2 /*return*/];
            case 4:
                request = new RequestsBuilder_1.RequestBuilder()
                    .withMethod(verb)
                    .withNodeName(nodeName)
                    .withNodeType(nodeType)
                    .withOriginalAction(action)
                    .build();
                nextAction = actions_1.apiActions.api.requests.push(request);
                return [4 /*yield*/, effects_1.put(nextAction)];
            case 5:
                _a.sent();
                return [2 /*return*/];
        }
    });
}
exports.get = get;
function root() {
    var actionTypes, _i, _a, actionType, apiInfo;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0: return [4 /*yield*/, effects_1.put(logger_1.logm('get saga on'))];
            case 1:
                _b.sent();
                return [4 /*yield*/, effects_1.select(selectors.$actionTypes)];
            case 2:
                actionTypes = (_b.sent());
                _i = 0, _a = Object.keys(actionTypes);
                _b.label = 3;
            case 3:
                if (!(_i < _a.length)) return [3 /*break*/, 6];
                actionType = _a[_i];
                apiInfo = actionTypes[actionType];
                if (!(apiInfo.isGet && !apiInfo.isLocal)) return [3 /*break*/, 5];
                return [4 /*yield*/, effects_1.takeEvery(actionType, get, apiInfo)];
            case 4:
                _b.sent();
                _b.label = 5;
            case 5:
                _i++;
                return [3 /*break*/, 3];
            case 6: return [2 /*return*/];
        }
    });
}
exports.default = root;
//# sourceMappingURL=get.js.map