"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var get_1 = require("./get/get");
var internet_1 = require("./internet/internet");
var logger_1 = require("./logger/logger");
var requests_1 = require("./requests/requests");
var save_1 = require("./save/save");
var sagas = {
    get: {
        saga: get_1.default,
        description: 'Handles data fetches from server, including pagination',
    },
    logger: {
        saga: logger_1.default,
        description: 'Captures logs system-wide',
    },
    requests: {
        saga: requests_1.default,
        description: 'Handles all XHR requests, implement error handling and retries.',
    },
    save: {
        saga: save_1.default,
        description: 'Handles all POST, PUT and PATCH actions, anything with side-effect',
    },
    internet: {
        saga: internet_1.internet,
        description: 'Checks whether an internet connection is available',
    },
};
exports.default = sagas;
//# sourceMappingURL=index.js.map