"use strict";
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProcessManager = exports.stopSaga = exports.startSaga = void 0;
var logger_1 = require("./logger/logger");
var effects_1 = require("redux-saga/effects");
var index_1 = require("./index");
var actions_1 = require("../connected/actions");
var date_1 = require("./_utils/date");
var startSaga = function (payload) { return ({
    type: 'START_SAGA',
    payload: payload,
}); };
exports.startSaga = startSaga;
var stopSaga = function (payload) { return ({
    type: 'STOP_SAGA',
    payload: payload,
}); };
exports.stopSaga = stopSaga;
var ProcessManager = /** @class */ (function () {
    function ProcessManager() {
        this.runningSagas = {};
        this.run = this.run.bind(this);
        this.start = this.start.bind(this);
        this.stop = this.stop.bind(this);
    }
    ProcessManager.prototype.start = function (action) {
        var payload, sagaId, saga, _a, _b, err_1;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _c.trys.push([0, 4, , 5]);
                    payload = action.payload;
                    sagaId = payload.sagaId;
                    return [4 /*yield*/, effects_1.put(logger_1.logm("START_SAGA: " + sagaId))];
                case 1:
                    _c.sent();
                    if (!index_1.default[sagaId]) {
                        throw new Error("START_SAGA: could not find sagaId \"" + sagaId + "\"");
                    }
                    saga = index_1.default[sagaId];
                    _a = this.runningSagas;
                    _b = sagaId;
                    return [4 /*yield*/, effects_1.fork(saga.saga)];
                case 2:
                    _a[_b] = (_c.sent());
                    return [4 /*yield*/, effects_1.put(actions_1.sagaActions.patch(sagaId, {
                            isRunning: true,
                            startedTS: date_1.timestamp(),
                        }))];
                case 3:
                    _c.sent();
                    return [3 /*break*/, 5];
                case 4:
                    err_1 = _c.sent();
                    console.log('function* start crashed ->', err_1);
                    return [3 /*break*/, 5];
                case 5: return [2 /*return*/];
            }
        });
    };
    ProcessManager.prototype.stop = function (action) {
        var payload, sagaId, err_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 4, , 5]);
                    payload = action.payload;
                    sagaId = payload.sagaId;
                    return [4 /*yield*/, effects_1.put(logger_1.logm("STOP_SAGA: " + sagaId))];
                case 1:
                    _a.sent();
                    if (!index_1.default[sagaId]) {
                        throw new Error("STOP_SAGA: could not find sagaId \"" + sagaId + "\"");
                    }
                    return [4 /*yield*/, effects_1.cancel(this.runningSagas[sagaId])];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, effects_1.put(actions_1.sagaActions.patch(sagaId, {
                            isRunning: false,
                            stoppedTS: date_1.timestamp(),
                        }))];
                case 3:
                    _a.sent();
                    return [3 /*break*/, 5];
                case 4:
                    err_2 = _a.sent();
                    console.log('function* stop crashed ->', err_2);
                    return [3 /*break*/, 5];
                case 5: return [2 /*return*/];
            }
        });
    };
    ProcessManager.prototype.run = function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, effects_1.takeEvery('START_SAGA', this.start)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, effects_1.takeEvery('STOP_SAGA', this.stop)];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, effects_1.put(logger_1.logm('process manager saga on'))];
                case 3:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    };
    return ProcessManager;
}());
exports.ProcessManager = ProcessManager;
exports.default = ProcessManager;
//# sourceMappingURL=process-manager.js.map