"use strict";
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.addRequest = void 0;
var actions = require("../../connected/quickActions");
var api = require("../_utils/api");
var selectors = require("../../selectors/selectors");
var actions_1 = require("./../../connected/actions");
var types_1 = require("../../types/types");
var effects_1 = require("redux-saga/effects");
var interval_1 = require("../_channels/interval");
var logger_1 = require("../logger/logger");
var PostApiActionBuilder_1 = require("./../_utils/PostApiActionBuilder");
var types_2 = require("./../../types/types");
var runningRequests = {};
var globalSettings;
function addRequest(request) {
    return {
        type: 'REQUEST',
        payload: { request: request },
    };
}
exports.addRequest = addRequest;
var patchRequest = actions_1.apiActions.api.requests.patch;
function fireRequest(request) {
    var meta, nodeName, id, response, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 11, , 12]);
                meta = request.meta, nodeName = request.nodeName;
                id = meta.id;
                runningRequests[id] = request;
                return [4 /*yield*/, effects_1.put(actions.onRequestStart(request))];
            case 1:
                _a.sent();
                return [4 /*yield*/, effects_1.put(actions.connectionChange(nodeName, types_1.ConnectionStatus.LOADING))];
            case 2:
                _a.sent();
                return [4 /*yield*/, effects_1.call(api.fireRequest, request)];
            case 3:
                response = _a.sent();
                return [4 /*yield*/, effects_1.put(actions.onRequestResponse(request, response))];
            case 4:
                _a.sent();
                return [4 /*yield*/, effects_1.put(actions.onApiStatusUpdate(request, response))];
            case 5:
                _a.sent();
                delete runningRequests[id];
                if (!!response.isSuccess) return [3 /*break*/, 8];
                return [4 /*yield*/, effects_1.put(actions.connectionChange(nodeName, types_1.ConnectionStatus.LOADING))];
            case 6:
                _a.sent();
                return [4 /*yield*/, effects_1.call(onError, request, response)];
            case 7:
                _a.sent();
                return [3 /*break*/, 10];
            case 8: return [4 /*yield*/, effects_1.call(onSuccess, request, response)];
            case 9:
                _a.sent();
                _a.label = 10;
            case 10: return [3 /*break*/, 12];
            case 11:
                err_1 = _a.sent();
                console.log('fireRequest saga crashed ->', err_1);
                return [3 /*break*/, 12];
            case 12: return [2 /*return*/];
        }
    });
}
function onRetry(request, response) {
    var delayBetweenRetries, nodeName;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                delayBetweenRetries = globalSettings.delayBetweenRetries;
                nodeName = request.nodeName;
                return [4 /*yield*/, effects_1.put(actions.connectionChange(nodeName, types_1.ConnectionStatus.RETRYING))];
            case 1:
                _a.sent();
                return [4 /*yield*/, effects_1.delay(delayBetweenRetries)];
            case 2:
                _a.sent();
                return [4 /*yield*/, effects_1.fork(fireRequest, request)];
            case 3:
                _a.sent();
                return [2 /*return*/];
        }
    });
}
function onError(request, response) {
    var retry, nodeName, nextAction;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, effects_1.call(shouldRetry, request)];
            case 1:
                retry = (_a.sent());
                nodeName = request.nodeName;
                return [4 /*yield*/, effects_1.put(actions.connectionChange(nodeName, types_1.ConnectionStatus.ERROR))];
            case 2:
                _a.sent();
                if (!retry) return [3 /*break*/, 5];
                return [4 /*yield*/, effects_1.put(actions.onRequestRetry(request))];
            case 3:
                _a.sent();
                return [4 /*yield*/, effects_1.call(onRetry, request, response)];
            case 4:
                _a.sent();
                return [2 /*return*/];
            case 5:
                nextAction = actions.apiError(request, response);
                request.resolve({ nextAction: nextAction, response: response });
                return [2 /*return*/];
        }
    });
}
function onSuccess(request, response) {
    var nodeName, postAction;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                nodeName = request.nodeName;
                return [4 /*yield*/, effects_1.put(actions.connectionChange(nodeName, types_1.ConnectionStatus.IDLE))];
            case 1:
                _a.sent();
                postAction = new PostApiActionBuilder_1.PostApiActionBuilder()
                    .withRequest(request)
                    .withResponse(response)
                    .build();
                request.resolve({ nextAction: postAction, response: response });
                return [2 /*return*/];
        }
    });
}
function shouldRetry(request) {
    var output, configs, config, _a, retryStrategy, _b, retriesCount;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                output = false;
                return [4 /*yield*/, effects_1.select(selectors.$config)];
            case 1:
                configs = (_c.sent());
                config = configs[request.nodeName];
                _a = config.retryStrategy, retryStrategy = _a === void 0 ? globalSettings.retryStrategy : _a;
                _b = request.retriesCount, retriesCount = _b === void 0 ? 0 : _b;
                switch (retryStrategy) {
                    case types_2.RetryStrategy.INDEFINITELY:
                        output = true;
                        break;
                    case types_2.RetryStrategy.NONE:
                        output = false;
                        break;
                    case types_2.RetryStrategy.X1_TIMES:
                        output = retriesCount + 1 < 1;
                        break;
                    case types_2.RetryStrategy.X2_TIMES:
                        output = retriesCount + 1 < 2;
                        break;
                    case types_2.RetryStrategy.X3_TIMES:
                        output = retriesCount + 1 < 3;
                        break;
                    case types_2.RetryStrategy.X4_TIMES:
                        output = retriesCount + 1 < 4;
                        break;
                    default:
                        output = false;
                }
                return [2 /*return*/, output];
        }
    });
}
function parseIncomingRequests() {
    var maxConcurrentRequests, requests, _i, requests_1, request, runningRequestsCount, availableSlots, i, request, err_2;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 10, , 11]);
                maxConcurrentRequests = globalSettings.maxConcurrentRequests;
                return [4 /*yield*/, effects_1.select(selectors.$idleRequests)];
            case 1:
                requests = (_a.sent());
                _i = 0, requests_1 = requests;
                _a.label = 2;
            case 2:
                if (!(_i < requests_1.length)) return [3 /*break*/, 5];
                request = requests_1[_i];
                return [4 /*yield*/, effects_1.put(patchRequest(request.meta.id, {
                        status: types_2.ApiRequestStatus.ON_QUEUE,
                    }))];
            case 3:
                _a.sent();
                _a.label = 4;
            case 4:
                _i++;
                return [3 /*break*/, 2];
            case 5:
                runningRequestsCount = Object.keys(runningRequests).length;
                availableSlots = maxConcurrentRequests - runningRequestsCount;
                i = 0;
                _a.label = 6;
            case 6:
                if (!(i < availableSlots)) return [3 /*break*/, 9];
                request = requests[i];
                if (!request) return [3 /*break*/, 8];
                return [4 /*yield*/, effects_1.fork(fireRequest, requests[i])];
            case 7:
                _a.sent();
                _a.label = 8;
            case 8:
                i++;
                return [3 /*break*/, 6];
            case 9: return [3 /*break*/, 11];
            case 10:
                err_2 = _a.sent();
                console.log('parseIncomingRequests saga crashed ->', err_2);
                return [3 /*break*/, 11];
            case 11: return [2 /*return*/];
        }
    });
}
function listenToRequestQueue() {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, effects_1.takeEvery(interval_1.intervalChannel(globalSettings.beat), parseIncomingRequests)];
            case 1:
                _a.sent();
                return [2 /*return*/];
        }
    });
}
function root() {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, effects_1.select(selectors.$apiGlobalSettings)];
            case 1:
                globalSettings = (_a.sent());
                return [4 /*yield*/, effects_1.put(logger_1.logm('requests saga on'))];
            case 2:
                _a.sent();
                return [4 /*yield*/, effects_1.fork(listenToRequestQueue)];
            case 3:
                _a.sent();
                return [2 /*return*/];
        }
    });
}
exports.default = root;
//# sourceMappingURL=requests.js.map