"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getConnectStoreDefinition = exports.getMainStoreDefinition = void 0;
var redux_store_generator_1 = require("redux-store-generator");
var reducers_1 = require("./connected/reducers");
var initialState_1 = require("./initialState");
var sagas_1 = require("./sagas");
var getMainStoreDefinition = function (state, options) {
    var initialState = redux_store_generator_1.cleanInitialState(state);
    var reducers = redux_store_generator_1.generateReducersForStore(state);
    return {
        initialState: initialState,
        reducers: reducers,
    };
};
exports.getMainStoreDefinition = getMainStoreDefinition;
var getConnectStoreDefinition = function (state, options) {
    var initialState = {
        _api: initialState_1.generateInitialState(state, options.endpointsConfig),
        _sagas: initialState_1.generateSagasInitialState(sagas_1.default),
    };
    var apiReducers = reducers_1.generateApiReducersForStore();
    var sagasReducers = reducers_1.generateSagasReducersForStore();
    return {
        initialState: initialState,
        reducers: __assign(__assign({}, apiReducers), sagasReducers),
    };
};
exports.getConnectStoreDefinition = getConnectStoreDefinition;
//# sourceMappingURL=storeDefinitions.js.map