import { Json } from 'redux-store-generator';

const report = (title: string, data: Json, isInput: boolean) => {
    const event = new CustomEvent('io', {
        detail: {
            title,
            isInput,
            data,
        },
    });
    document.dispatchEvent(event);
};

export const input = (title: string, data: Json) => report(title, data, true);
export const output = (title: string, data: Json) => report(title, data, false);
